/* 
	Download DrWeb antivirus bases
	------------------------------

						Vasilkin Andrey, 2005 y.
*/

/****************************************************************/
/*                         Settings                             */
/****************************************************************/

CurVer = '432'               /* DrWeb Version (without dots)    */
DestDir = 'c:\DrWeb\'        /* Store path                      
                                default, DestDir=script source 
                                path                            */
DestDir2 = 'h:\'             /* Duplicate path 
                                if DestDir2='', no duplicates   */

/* --- Source FTP servers --- */
FTPServer.0 = 2

FTPServer.1.addr = '81.211.104.2'
FTPServer.1.path = '/pub/bases'

FTPServer.2.addr = '81.211.104.11'
FTPServer.2.path = '/pub/bases'     

/****************************************************************/
/*                       MAIN PROGRAM                           */
/****************************************************************/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

call RxFuncAdd 'FtpLoadFuncs', 'rxFTP', 'FtpLoadFuncs'
call FtpLoadFuncs

if DestDir='' then
do
  PARSE SOURCE rubbish rubbish DestDir
  j = LASTPOS('\', DestDir)
  if j > 0 then DestDir = left(DestDir, j)
end
if right(DestDir,1)\='\' then DestDir = DestDir || '\'

do i = 1 to FTPServer.0 
  rc = FTPLogon(FTPServer.i.addr,FTPServer.i.path)
  if rc = 0 then leave
end
if rc = -1 then ScriptError('Connection was not established');

call SysFileTree DestDir'drw'CurVer'*.VDB', files, 'FO'

Count = 0
do i=1 to ftplst.0

  /* --- compare source and local lists of files --- */
  present = 0
  do j=1 to files.0
    S = substr(files.j,length(DestDir)+1)
    S = translate(substr(S,1,pos('.',S)-1))
    S1 = translate(substr(ftplst.i,1,pos('.',ftplst.i)-1))
    if S=S1 then
    do
      present = 1
      leave
    end
  end

  if present=0 then
  do
    say 'Downloading new file 'ftplst.i' to 'DestDir

    rc = FtpGet(DestDir || ftplst.i,ftplst.i,"Binary")
    if rc = -1 then
      ScriptError('Can''t download ' || ftplst.i || ' to ' || DestDir)
    else if rc=0 then
    do
      if DestDir2\='' then
      do
        say '  store duplicate to 'DestDir2
        '@copy ' || DestDir || ftplst.i || ' ' || DestDir2
      end
      say '  done.'
      Count = Count+1
    end
    else say 'Warning: FtpGet() rc='rc
  end
end

call FtpLogoff
say
if Count=0 then say 'No news files on the server'
else say 'Received 'Count' new file(s).'

/* --- create List-file --- */
if Count > 0 then
do
  ListFile = DestDir'drweb32.lst'
  call SysFileDelete ListFile
  call lineout ListFile,'['CurVer']'
  rc = SysFileTree(DestDir'drw'CurVer'*.VDB',files,'FO')
  do j=1 to files.0
    S = substr(files.j,length(DestDir)+1)
    call lineout ListFile,'+'S','
  end
  call stream ListFile,'c','close'
end

EXIT


FTPLogon: PROCEDURE EXPOSE ftplst. CurVer
  FTPServer = arg(1)
  FTPPath = arg(2)
  say 'Connecting to ' || FTPServer || '...'

  rc = FtpSetUser(FTPServer,'anonymous','')

  res = 0
  if FtpChDir(FTPPath) = -1 then
  do
    say 'Can''t connect to server "'FTPServer'" or CD "'FTPPath'"'
    res = -1
  end
  else do
    say 'Reading list of files...'
    if FtpLs('drw'CurVer'*.vdb','ftplst.') = -1 then
    do
      say 'Can''t get list of files on source FTP-server'
      res = -1
    end
    else 
      if ftplst.0 = 0 then
      do
        say 'There are no drw'CurVer'*.VDB files on source FTP-server'
        res = -1
      end
  end
return res

ScriptError:
  line = arg(1)
  say 'Error: 'line
exit 1
